
/*****************************************************************************
 *
 * CYCLOTRON
 * xpindr00.cpp
 *
 * Authors: MILAN PINDRYC xpindr00
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
*****************************************************************************/

#if defined(__WIN32__) || defined(_WIN32)
// Pro linker: Budeme linkovat s main,
// nikoliv WinMain, jak je na Windows zvykem
#pragma comment(linker, "/entry:\"mainCRTStartup\"")

#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#else
#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#endif
#include <vector>
#include <map>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoTriangleStripSet.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoIndexedNurbsCurve.h>
#include <Inventor/nodes/SoCylinder.h>
#include <Inventor/nodes/SoCube.h>

#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoEnvironment.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/sensors/SoOneShotSensor.h>
#include <Inventor/nodes/SoText2.h>

///////////////////
#include <Inventor/nodes/SoCallback.h> 
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/SoPickedPoint.h>
#include <Inventor/actions/SoRayPickAction.h>
#include <Inventor/events/SoMouseButtonEvent.h>
#include <Inventor/nodes/SoFont.h>
////////////////////
#include <iostream>
#include <sstream>
using namespace std;
#include <stdio.h>
#include <math.h>
#include <cstdlib>


#define MAX_ELEKTRONU 10
#define pruhlednost 0.5
#define velikost_elektronu 1
#define detail_valec 30

float E_max=1.5;
SoText2 * b6;
#define m_castice 1.673 //*10na-27
#define q_castice 1.602 //*10na-19
float B=5;
SoText2 * b3;
float zpomaleni=5;

#define presnost 500
float ratio=1;
SoText2 * b9;
#define frekvence q_castice * B /m_castice *ratio
SoSeparator *sceneRoot;                 //koren sceny
SbTime lastTimeTick = SbTime::zero();	// cas minuleho pocitani pozic objektu
SoOneShotSensor *sensor;		// senzor
void aktivuj_elektron();
inline string stringify(int x);


SoOrthographicCamera * camera;


int numelektrons;

int flag_zobrazeni=0;
SoSeparator * vrsek;
SoSeparator * h_magnet;
SoSeparator * l_pul;
SoSeparator * p_pul;
SoSeparator * ld_pul;
SoSeparator * pd_pul;
SoSeparator * l_ob;
SoSeparator * p_ob;



//////////////////////////////////////////////////////////////////////////

static void
event_cb(void * ud, SoEventCallback * n)
{
  const SoMouseButtonEvent * mbe = (SoMouseButtonEvent *)n->getEvent();

  if (mbe->getButton() == SoMouseButtonEvent::BUTTON1 &&
      mbe->getState() == SoButtonEvent::DOWN) {
    SoWinExaminerViewer * viewer = (SoWinExaminerViewer *)ud;	
	
	SoRayPickAction rp(viewer->getViewportRegion());
    rp.setPoint(mbe->getPosition());	
    rp.apply(viewer->getSceneManager()->getSceneGraph());

    SoPickedPoint * point = rp.getPickedPoint();
    if (point == NULL) { //nic nebylo vybrano      
      return;
    }

    

	SoNode * MyNode = point->getPath()->getTail(); //jaky objekt se vybral

	SoText2  * pickedBtn; //sem si ulozim vybrane tlacitko/elektron
	
	n->setHandled();	

    if (MyNode->getTypeId() == SoText2::getClassTypeId()){ //je to tlacitko
		pickedBtn = (SoText2 *) MyNode;
	} else return;
	
	

	

   ///osetreni buttonu


	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "New electron")){		   
		aktivuj_elektron();
	}


	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "Zpomal")){		   
	zpomaleni+=0.5;	
	}
	
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "Zrychli")){		   
		if (zpomaleni > 0.5){zpomaleni-=0.5;}	
	}

	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "B++")){		   
		if (B < 10){B+=0.5;}	
		string s_b3="B="+stringify(B*10);
		b3->string = s_b3.c_str();
	}
	
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "B--")){		   
		if (B > -10){B-=0.5;}
		string s_b3="B="+stringify(B*10);
		b3->string = s_b3.c_str();
	}
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "E++")){		   
		if (E_max < 5){E_max+=0.5;}	
		string s_b6="E="+stringify(E_max*10);
		b6->string = s_b6.c_str();
	}
	
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "E--")){		   
		if (E_max > -5){E_max-=0.5;}
		string s_b6="E="+stringify(E_max*10);
		b6->string = s_b6.c_str();
	}
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "r++")){		   
		if (ratio < 5){ratio+=0.1;}	
		string s_b9="ratio="+stringify(ratio*10);
		b9->string = s_b9.c_str();
	}
	
	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "r--")){		   
		if (ratio > 0.1){ratio-=0.1;}
		string s_b9="ratio="+stringify(ratio*10);
		b9->string = s_b9.c_str();
	}
  
  	if (!strcmp(pickedBtn->string.getValues(0)->getString(), "ZOBRAZENI")){		   
		if (flag_zobrazeni==0){
			
			flag_zobrazeni=1;
		
			SoNode	*child;
			child=vrsek->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}
	
			child=h_magnet->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}
		
			child=p_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}
		
			child=l_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}		

			child=pd_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}
		
			child=ld_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}

			child=p_ob->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}
		
			child=l_ob->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=1;}	

		}
	
		else{
			
			flag_zobrazeni=0;
		
			SoNode	*child;
			child=vrsek->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=0;}
	
			child=h_magnet->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=0;}
		
			child=p_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}
		
			child=l_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}		

			
			child=pd_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}
		
			child=ld_pul->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}

			child=p_ob->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}
		
			child=l_ob->getChild(0);
			if(child->isOfType(SoMaterial::getClassTypeId())){
			SoMaterial*f = (SoMaterial *)child;
			f->transparency=pruhlednost;}	

		}	
	}
  

  
  
  
  }





}

//callback fce aby se menu nerozjizdelo ... od Ing.Jana Pecivy

static void
overlayViewportCB(void *, SoAction *action)
{

	   if (action->isOfType(SoGLRenderAction::getClassTypeId())) {
       const SbViewportRegion &vr =
                  ((SoGLRenderAction*)action)->getViewportRegion();
       float pointSize = 2.f / 357; // 2.f is default camera view height and 357 default window height
                                    // Dividing 2.f by 357 we receive size of one point on the screen.
       camera->height = pointSize * vr.getWindowSize()[1]; // we will receive the same point resolution on each window size
       float posX = (float(vr.getWindowSize()[0]) / 2.f - 20) * pointSize;
       float posY = -camera->height.getValue() / 2.f + pointSize * 20.f;
       camera->position.setValue(posX, posY, 1.f);

   }
  }


SoSeparator * MakeMenu(SoWinExaminerViewer * viewer){
	SoSeparator * MyMenu = new SoSeparator;




	    // Add a callback node which will set the viewport
    SoCallback *overlayCB = new SoCallback;
    overlayCB->setCallback(overlayViewportCB);
    MyMenu->addChild(overlayCB);


	camera = new SoOrthographicCamera;

	MyMenu->addChild(camera);



    SoEventCallback * ecb = new SoEventCallback; //callback udalosti pro mys
    ecb->addEventCallback(SoMouseButtonEvent::getClassTypeId(), event_cb, viewer);
    MyMenu->addChild(ecb);

	SoMaterial *material0 = new SoMaterial;
	material0->diffuseColor.setValue(SbColor(0.6f, 0.6f, 0.6f));
	MyMenu->addChild(material0);

	SoFont *myFont = new SoFont;
    myFont->name.setValue("Arial");
    myFont->size.setValue(20);
    MyMenu->addChild(myFont);  
	
//novej elektron    


    
	SoText2 * b0 = new SoText2();
	b0->string = "New electron";
	MyMenu->addChild(b0);
// zpomal
	SoTranslation * t1 = new SoTranslation;
	t1->translation.setValue(0.0,-0.2,0.0);
	MyMenu->addChild(t1);	
	
	SoText2 * b1 = new SoText2();
	b1->string = "Zpomal";
	MyMenu->addChild(b1);

//zrychli

	SoTranslation * t2 = new SoTranslation;
	t2->translation.setValue(0.5,0.0,0.0);
	MyMenu->addChild(t2);	
	
	SoText2 * b2 = new SoText2();
	b2->string = "Zrychli";
	MyMenu->addChild(b2);


//B
	SoMaterial *material1 = new SoMaterial;
	material1->diffuseColor.setValue(SbColor(1.f, 0.0f, 0.0f));
	MyMenu->addChild(material1);
	
	SoTranslation * t3 = new SoTranslation;
	t3->translation.setValue(-0.5,-0.2,0.0);
	MyMenu->addChild(t3);	
	
	b3 = new SoText2();
	string s_b3="B="+stringify(B*10);
	b3->string = s_b3.c_str();
	MyMenu->addChild(b3);
//B-
	MyMenu->addChild(material0);
	
	SoTranslation * t4 = new SoTranslation;
	t4->translation.setValue(0.4,0.0,0.0);
	MyMenu->addChild(t4);	
	
	SoText2 *b4 = new SoText2();
	b4->string = "B--";
	MyMenu->addChild(b4);


//B+

	
	SoTranslation * t5 = new SoTranslation;
	t5->translation.setValue(0.4,0.0,0.0);
	MyMenu->addChild(t5);	
	
	SoText2 *b5 = new SoText2();
	b5->string = "B++";
	MyMenu->addChild(b5);



//E

	MyMenu->addChild(material1);
	
	SoTranslation * t6 = new SoTranslation;
	t6->translation.setValue(-0.8,-0.2,0.0);
	MyMenu->addChild(t6);	
	
	b6 = new SoText2();
	string s_b6="E="+stringify(E_max*10);
	b6->string = s_b6.c_str();
	MyMenu->addChild(b6);
//E-
	MyMenu->addChild(material0);
	
	SoTranslation * t7 = new SoTranslation;
	t7->translation.setValue(0.4,0.0,0.0);
	MyMenu->addChild(t7);	
	
	SoText2 *b7 = new SoText2();
	b7->string = "E--";
	MyMenu->addChild(b7);


//E+

	
	SoTranslation * t8 = new SoTranslation;
	t8->translation.setValue(0.4,0.0,0.0);
	MyMenu->addChild(t8);	
	
	SoText2 *b8 = new SoText2();
	b8->string = "E++";
	MyMenu->addChild(b8);

//ratio

	MyMenu->addChild(material1);
	
	SoTranslation * t9 = new SoTranslation;
	t9->translation.setValue(-0.8,-0.2,0.0);
	MyMenu->addChild(t9);	
	
	b9 = new SoText2();
	string s_b9="ratio="+stringify(ratio*10);
	b9->string = s_b9.c_str();
	MyMenu->addChild(b9);
//ratio-
	MyMenu->addChild(material0);
	
	SoTranslation * t10 = new SoTranslation;
	t10->translation.setValue(0.6,0.0,0.0);
	MyMenu->addChild(t10);	
	
	SoText2 *b10 = new SoText2();
	b10->string = "r--";
	MyMenu->addChild(b10);


//ratio+

	
	SoTranslation * t11 = new SoTranslation;
	t11->translation.setValue(0.4,0.0,0.0);
	MyMenu->addChild(t11);	
	
	SoText2 *b11 = new SoText2();
	b11->string = "r++";
	MyMenu->addChild(b11);


//ZOBRAZENI

	
	SoTranslation * t12 = new SoTranslation;
	t12->translation.setValue(-1.,-0.2,0.0);
	MyMenu->addChild(t12);	
	
	SoText2 *b12 = new SoText2();
	b12->string = "ZOBRAZENI";
	MyMenu->addChild(b12);

	return MyMenu;
}







////////////////////////////////////////////////////////////////////////////











///********************* electron***********************


class elektron
{
	public:
		elektron(float p_x,float p_y,float p_z, SbColor color,float size);
		static void updatePositions(float E,vector<elektron> &elektrons,const SbTime dt,unsigned int numelektrons);	
		void setPosition(float E,float delta_time,vector<elektron> &elektrons);
		void getPosition(float *array);
		void getSpeed(float *speed);
		void getFlag(float *fl);
		void setFlag(float *fl);
		int cislo;
		int aktivni;
	private:
		SoMaterial * material;
		SoTranslation *trans;
		SoText2 * btn1;
		SoSphere *koule;
		float Flag,Flag2;
		float a_x;
		float a_y;
		float a_z;
		SbColor barva;
		float speed_x,speed_y,speed_z;

     
};






elektron::elektron(float p_x,float p_y,float p_z, SbColor color,float size)
{
if (sceneRoot == NULL)
	return;

	SoSeparator *root = new SoSeparator;
    barva=color;
	cislo=numelektrons;
	aktivni=0;
	speed_x=0.0;
	speed_y=((rand()%100)-50)/250.0;	
	speed_z=0.0;
	Flag=1;
	Flag2=1;
	a_x = p_x;
	a_y = p_y;
	a_z = p_z;
    trans = new SoTranslation;
    trans->translation.setValue(p_x,p_y,p_z);
    root->addChild(trans);

	

	material = new SoMaterial;
	material->diffuseColor.setValue(color);
	root->addChild(material);

	koule = new SoSphere;
	koule->radius.setValue(size);
	root->addChild(koule);

 	
	btn1= new SoText2();

	btn1->string = "";
	root->addChild(btn1); 

	sceneRoot->addChild(root);

}

void elektron::setPosition(float E,float delta_time,vector<elektron> &elektrons) {
float flag3=0;
float d_speed[3]; 
string st;
st="  rychlost "+stringify(sqrt(speed_x*speed_x+speed_z*speed_z)*10);
btn1->string=st.c_str();

		for (int lt=0;lt<presnost;lt++){
		float pom_d_speed=0;
		
	

			if((a_x*Flag)<=0){
				Flag=-Flag;
				flag3=1;
				pom_d_speed=q_castice/m_castice*E;
		
			}


			d_speed[0]=pom_d_speed+((speed_z)*B*q_castice/m_castice*delta_time/presnost);
			d_speed[1]=0;
			d_speed[2]=-((speed_x)*B*q_castice/m_castice*delta_time/presnost);
		
			
			if ((a_z<-6) && flag3){	Flag2=0;}//konec urychlovn
			
			if (Flag2==1)
				{a_x = a_x+d_speed[0]*delta_time/presnost+speed_x*delta_time/presnost;
				a_y = a_y+d_speed[1]*delta_time/presnost+speed_y*delta_time/presnost;
				a_z = a_z+d_speed[2]*delta_time/presnost+speed_z*delta_time/presnost;
				speed_x = speed_x+d_speed[0];
				speed_y = speed_y+d_speed[1];
				speed_z = speed_z+d_speed[2];
			}
			else{
				a_x = a_x+speed_x*delta_time/presnost;
				a_y = a_y+speed_y*delta_time/presnost;
				a_z = a_z+speed_z*delta_time/presnost;
				}
			if (a_x<-15){
				//smazani elektronu
				aktivni=0;
				btn1->string="";
				a_x=0;
				a_y=0;
				a_z=0;
				speed_x=0.0;
				speed_y=((rand()%100)-50)/250.0;
				speed_z=0.0;
				Flag=1;
				Flag2=1;
				lt=presnost;			
				}

		
		}	
		


if((((sqrt(a_z*a_z+a_x*a_x)<=-7)||(sqrt(a_z*a_z+a_x*a_x)>=7)) && (Flag2))||(a_y<-1.5)||(a_y>1.5))//kolize se stenou urychlovace
	{
					//smazani elektronu
				aktivni=0;
				btn1->string="";
				a_x=0;
				a_y=0;
				a_z=0;
				speed_x=0.0;
				speed_y=((rand()%100)-50)/250.0;
				speed_z=0.0;
				Flag=1;
				Flag2=1;

	}	


trans->translation.setValue(a_x,a_y,a_z);




if (sceneRoot == NULL)
	return;

	SoSeparator *r = new SoSeparator;

    SoTranslation *tr = new SoTranslation;
    tr->translation.setValue(a_x,a_y,a_z);
    r->addChild(tr);


	SoMaterial *ma = new SoMaterial;
	ma->diffuseColor.setValue(barva);
	r->addChild(ma);

	SoCube *koule = new SoCube;  // "koule":-) krychle mam min trohelniku
  koule->height.setValue(0.03f);
  koule->width.setValue(0.03f);
  koule->depth.setValue(0.03f);
  r->addChild(koule);


	sceneRoot->addChild(r);




}

void elektron::getFlag(float *fl) {

	fl[0] = Flag;
}


void elektron::setFlag(float *fl) {

	Flag = fl[0];
}


	
	


void elektron::getPosition(float *array) {
	array[0] = a_x;
	array[1] = a_y;
	array[2] = a_z;
}
void elektron::getSpeed(float *speed) {
	speed[0] = speed_x;
	speed[1] = speed_y;
	speed[2] = speed_z;
}




void elektron::updatePositions(float E,vector<elektron> &elektrons,const SbTime dt,unsigned int numelektrons) {

	float delta_time = dt.getValue();

	for (int loop=0; loop<elektrons.size();loop++){

		if (elektrons[loop].aktivni!=0) elektrons[loop].setPosition(E,delta_time,elektrons);
		
	}	
		
}




//**********************************************
vector <elektron> elektrons;



//***********aktivace 1 elektronu******************
void aktivuj_elektron(){
	for (int loop1=0; loop1<elektrons.size();loop1++){
		if (elektrons[loop1].aktivni==0) {
			elektrons[loop1].aktivni=1;
			return;
		}
	}
}




//*************call back**************************************




SbTime dt;

SbTime cas_zacatku=SbTime::getTimeOfDay();

void sensorCallback(void *, SoSensor *sensor) {
	SbTime dt, ct = SbTime::getTimeOfDay();

	if (lastTimeTick == SbTime::zero()) {
		lastTimeTick = ct;
		sensor->schedule();
		return;
	}

	dt = ct - lastTimeTick;
	lastTimeTick = ct;
	
	float E = E_max*cos(frekvence*(cas_zacatku.getValue() - ct.getValue())/zpomaleni);

	elektron::updatePositions(E,elektrons,dt/zpomaleni,numelektrons);
	
	sensor->schedule();
}
// ********************** valec ****************


SoSeparator* createValec(float radius,float hight, float distance,SbColor color)
{
  SoSeparator *root = new SoSeparator;

  // Materil planety
  SoMaterial *material = new SoMaterial;
  material->diffuseColor.setValue(color);
  root->addChild(material);






  SoTranslation *trans = new SoTranslation;
  trans->translation.setValue(0.f, distance,0.f);
  root->addChild(trans);


  SoCylinder *valec = new SoCylinder;
  valec->height.setValue(hight);
  valec->radius.setValue(radius);
  root->addChild(valec);

  return root;
}

//********************* Pul obruc  ***********************
SoSeparator* createPulobruc(float distance_z,float radius,float hight, float distance_x,SbColor color)
{
  SoSeparator *root = new SoSeparator;

  // Materil
	SoMaterial *bronze = new SoMaterial;
	bronze->ambientColor.setValue(.33, .22, .27);
	bronze->diffuseColor.setValue(.78, .57, .11);
	bronze->specularColor.setValue(.99, .94, .81);
	bronze->shininess = .28;
	bronze->transparency=pruhlednost;

	root->addChild(bronze);



  // Vzdlenost
  SoTranslation *trans = new SoTranslation;
  trans->translation.setValue(distance_x, -hight/2,distance_z);
  root->addChild(trans);
float c[detail_valec];
float d[detail_valec];
int i;
for(i=0;i<(detail_valec-1);i++)
	{
	float b;
	b=180/(detail_valec-1)*M_PI/180*i;
	c[i]=sin(b);
	d[i]=cos(b);
	}
c[detail_valec-1]=0;
d[detail_valec-1]=-1;


float vertices[detail_valec*2][3];
int j;
for(j=0;j<(detail_valec*2);j++)
{
vertices[j][0]=c[j / 2]*radius;
vertices[j][1]=(j % 2)*hight;
vertices[j][2]=d[j / 2]*radius;
}
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0,detail_valec*2, vertices);
  root->addChild(coords);

SoTriangleStripSet *strip = new SoTriangleStripSet;

    strip->numVertices.set1Value(0, detail_valec*2);
  root->addChild(strip);

  return root;
}

//************************** pul kruh **********************

SoSeparator* createPulkruh(float distance_z,float radius,float hight, float distance_x,int poz, SbColor color)
{
  SoSeparator *root = new SoSeparator;

 // Materil
	SoMaterial *bronze = new SoMaterial;
	bronze->ambientColor.setValue(.33, .22, .27);
	bronze->diffuseColor.setValue(.78, .57, .11);
	bronze->specularColor.setValue(.99, .94, .81);
	bronze->shininess = .28;
	bronze->transparency=pruhlednost;

    root->addChild(bronze);




  // Vzdlenost
  SoTranslation *trans = new SoTranslation;
  trans->translation.setValue(distance_x, -hight/2+poz*hight,distance_z);
  root->addChild(trans);
float c[detail_valec];
float d[detail_valec];
int i;
for(i=0;i<detail_valec-1;i++)
	{
	float b;
	b=180/(detail_valec-1)*M_PI/180*i;
	c[i]=sin(b);
	d[i]=cos(b);
	}
c[detail_valec-1]=0;
d[detail_valec-1]=-1;


float vertices[detail_valec][3];
int k;
for(k=0;k<detail_valec;k++)
	{
	if ((k%2)==0){
		vertices[k][0]=c[(k+1)/2]*radius;
		vertices[k][1]=0;
		vertices[k][2]=d[(k+1)/2]*radius;
		}
	else
		{
		vertices[k][0]=c[detail_valec-(k+1)/2]*radius;
		vertices[k][1]=0;
		vertices[k][2]=d[detail_valec-(k+1)/2]*radius;

		}
	}

 SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0,detail_valec, vertices);
  root->addChild(coords);

SoTriangleStripSet *strip = new SoTriangleStripSet;

    strip->numVertices.set1Value(0, detail_valec);
  root->addChild(strip);

  return root;
}
//*********************krabice************************

SoSeparator* createKrabici(float height,float width,float depth,float x,float y, float z,SbColor color)
{
  SoSeparator *root = new SoSeparator;

  // Materil planety
  SoMaterial *material = new SoMaterial;
  material->diffuseColor.setValue(color);
  root->addChild(material);





  // Vzdlenost
  SoTranslation *trans = new SoTranslation;
  trans->translation.setValue(x,y,z);
  root->addChild(trans);

  // Model planety
  SoCube *krychle = new SoCube;
  krychle->height.setValue(height);
  krychle->width.setValue(width);
  krychle->depth.setValue(depth);
  root->addChild(krychle);

  return root;
}








//**** main***************************************************************

//*************strigify***************
inline string stringify(int x)
 {
   ostringstream o;
   o << x;     
   return o.str();
}



int main(int , char **argv)
{
  // Inicializuj Inventor
#if defined(__WIN32__) || defined(_WIN32)
  HWND window = SoWin::init(argv[0]);
#else
  QWidget *window = SoQt::init(argv[0]);
#endif
  if (window == NULL) exit(1);

  // Vytvo koen scny
  sceneRoot = new SoSeparator;
  sceneRoot->ref();

  // Vlo kameru do scny
  SoPerspectiveCamera *camera = new SoPerspectiveCamera;
  sceneRoot->addChild(camera);

   SoEnvironment *env = new SoEnvironment;
  env->ambientIntensity.setValue(1.0);
  sceneRoot->addChild(env);

  SoShapeHints *sh = new SoShapeHints;
  sh->vertexOrdering.setValue(SoShapeHints::COUNTERCLOCKWISE);
  sh->shapeType.setValue(SoShapeHints::UNKNOWN_SHAPE_TYPE);
  sceneRoot->addChild(sh);

  SoComplexity *c = new SoComplexity;
  c->value.setValue(1.f);
  sceneRoot->addChild(c);

  // Svtlo
  /*SoDirectionalLight *sunLight = new SoDirectionalLight;
  sunLight->direction.setValue(1.0f, 1.0f, 1.0f);
  sunLight->intensity.setValue(1.0f);
  sceneRoot->addChild(sunLight);*/

  
  h_magnet=createValec(7.0f,5 ,5.f,SbColor(0.7f, 0.7f, 1.0f));
  sceneRoot->addChild(h_magnet);

  sceneRoot->addChild(createValec(7.0f,5 ,-5.f,
                              SbColor(0.7f, 0.1f, 0.1f)));

  sceneRoot->addChild(createValec(0.2f, 0.2f,0,
                            SbColor(0.f, 0.5f, 1.f)));

  
  l_ob=createPulobruc(0.5f,-6.5f,3, -0.2f,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(l_ob);

  p_ob=createPulobruc(0.f,7.0f,3, 0.2f,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(p_ob);
  
  l_pul=createPulkruh(0.5f,-6.5f,3, -0.2f,1,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(l_pul);

  ld_pul=createPulkruh(0.5f,-6.5f,3, -0.2f,0,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(ld_pul);

  p_pul=createPulkruh(0,7.0f,3, 0.2f,1,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(p_pul);

  pd_pul=createPulkruh(0,7.0f,3, 0.2f,0,SbColor(0.78f,0.57f,0.11f));
  sceneRoot->addChild(pd_pul);

 sceneRoot->addChild(createKrabici(15.0f,5.0f,5.0f,15.f,0.f,0.f,SbColor(0.4f,0.41f,0.31f)));
 sceneRoot->addChild(createKrabici(15.0f,5.0f,5.0f,-15.f,0.f,0.f,SbColor(0.4f,0.41f,0.31f)));
 vrsek=createKrabici(5.0f,45.0f,15.0f,0.f,10.f,0.f,SbColor(0.28f,0.1f,0.11f));
 sceneRoot->addChild(vrsek);
 sceneRoot->addChild(createKrabici(5.0f,45.0f,15.0f,0.f,-10.5f,0.f,SbColor(0.28f,0.1f,0.11f)));
 sceneRoot->addChild(createKrabici(-5.0f,1.0f,5.0f,-15.f,0.f,-5.f,SbColor(0.7f,0.1f,0.7f)));



	sensor = new SoOneShotSensor(sensorCallback, NULL);
	sensor->schedule();
  
 
elektron *a;   
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;
a=new elektron(0.0,0.0,0.0,SbColor(rand()%10/10.0,rand()%10/10.0,rand()%10/10.0),velikost_elektronu*0.1f);
elektrons.push_back(*a);numelektrons++;

//aktivuj_elektron();
 
  // Vytvo okno prohlee
#if defined(__WIN32__) || defined(_WIN32)
  SoWinExaminerViewer *viewer = new SoWinExaminerViewer(window);
#else
  SoQtExaminerViewer *viewer = new SoQtExaminerViewer(window);
#endif

  SoSeparator * menu = MakeMenu(viewer);
  sceneRoot->addChild(menu);

  
  
  viewer->setSceneGraph(sceneRoot);
  viewer->setTitle("CYKLOTRON");
  viewer->show();

  // Zobraz okna a rozje renderovac smyku
#if defined(__WIN32__) || defined(_WIN32)
  SoWin::show(window);
  SoWin::mainLoop();
#else
  SoQt::show(window);
  SoQt::mainLoop();
#endif

  // Uvolni pam
 delete viewer;
  sceneRoot->unref();;

  return 0;
}


























